#!/usr/local/bin/perl -w
#use strict;
use  LWP::Simple;
use  LWP::UserAgent;
use HTTP::Response;
use HTML::Tree;
use POSIX; 
$| = 1;
# Set this parametr. This is the path where the Wikipedia entries will be stored
require 'config.pl';
#my $outdir = "../wiki_entries_test/";

my $persons_per_page = 500;
# Check this -- Wikipedia seems to be decreasing the limit. It used to be 1000,
# now Wikipedia only permits 500.

for (my $year=1940; $year <= 2010; $year++) {
	my $decade = floor ($year / 10);
	$decade = $decade . "0";
	my $outfolder = $outdir . "/" . $decade;
	system ("mkdir $outfolder");	
	my $outfile = "$outdir" . $decade . "/" . $year . ".all";
	print "year $year decade $decade $outfile\n";

	my $browser = LWP::UserAgent->new;
#this worked before, but not anymore. Changed July 17,2011 for distribution.
# The commented out URL is the one that was actually used to download the data
	my $URL = "http://en.wikipedia.org/w/index.php?title=Special%3ASearch&redirs=1&search=\"$year+births\"+AND+American&limit=$persons_per_page&offset=0";
	my $response =  $browser->get ($URL); 
			
	my $content = $response->content;
#	print $content;
        $content =~ s/\r\n/\n/g;
        $content =~ s/\r/\n/g;
	 my @lines = split (/\n/, $content);
####################
# figure out how many individuals born in this year
my $loc1 = index ($content, "Results");
my $tmp_str = substr ($content, $loc1, 100); # just et 100 characters 
$loc1= index ($tmp_str, "of");
$tmp_str = substr ($tmp_str, $loc1, 100);
$_ = $tmp_str;
/\<b\>([0-9\,]+)\<\/b\>/;
my $total_individuals = $1;

print "tmp-strp $tmp_str total individuals $total_individuals\n";

####################
$persons_per_page =~ s/\,//g;
$total_individuals =~ s/\,//g;

print "total $total_individuals persons $persons_per_page\n";
	my $number_of_pages_to_query = 
		roundup ($total_individuals/$persons_per_page);
	get_people ($outfile , @lines );

	my $j=1; # gone through one page
	while ($j <= $number_of_pages_to_query ) {

print "j is $j number of pages $number_of_pages_to_query\n";
		my $offset = $j * $persons_per_page + 1; 
	$URL = "http://en.wikipedia.org/w/index.php?title=Special%3ASearch&redirs=1&search=\"$year+births\"+AND+American&limit=$persons_per_page&offset=$offset";
        	my $response =  $browser->get ($URL);

	        my $content = $response->content;
#       print $content;
       		$content =~ s/\r\n/\n/g;
	        $content =~ s/\r/\n/g;
		 my @lines = split (/\n/, $content); 
		get_people ($outfile , @lines);
		$j++;
	} # gone through all pages for this year
} # end gone through all years


sub
get_people
{
	my ($outfile, @content) = @_;

	open (OUT, ">>$outfile") || die "can't open $outfile";
#print "lines for content " . @content . "\n";
	for (my $j = 0; $j < @content; $j++) {
#print "line $j " . $content[$j] . "\n";
	#	if ($content[$j] =~ /^\<li\>\<a href/) {
		# modified on July 17,2011 because Wikipedia changed structure
		if ($content[$j] =~ /\<a href/ && $content[$j] =~ /title=/ &&
			$content[$j] =~ /search-result/) {
#print "in if $content[$j]\n";
#			$content[$j] =~ s/\<li\>//;
#			my $loc2 = index ($content[$j] , ">");
			my $loc = index ($content[$j] , "<a href");
			my $tmp_str = substr ($content[$j], $loc , 1000);
			my $loc2 = index ($tmp_str, ">");
#print "tmp_str $tmp_str\n";
			$tmp_str =substr ($tmp_str, 0, $loc2-1);
			$tmp_str =~ s/<a href=//;
			$tmp_str =~ s/title=//;
			$tmp_str =~ s/\"//g;

			$tmp_str =~ s/\>//g;
			print OUT $tmp_str . "\n"; 
		}
	}
	close (OUT);
}


sub roundup {
    my $n = shift;
    return(($n == int($n)) ? $n : int($n + 1))
}

