#!/usr/bin/perl
#use strict;
use POSIX;
require "./SUBROUTINES.pl";
require "./STAT.pl";
require "config.pl";

my $category = ""; # empty string for all Wikipedia entries.  
		   #  Other options are Arts or Sports  etc.
#my $category = "Arts";
#my $category = "Sports";

my %state_conversion_hash = make_hash ( $states_abbrev_file ,
	#"/home/pauline/wiki/cities/states.csv",
						1,0,",");
my %long_state_to_abbrev_hash = make_hash ($states_abbrev_file ,
	#"/home/pauline/wiki/cities/states.csv", 
						0,1,",");

my (%wiki_state_hash) =
				 read_wiki_states ($category, %state_conversion_hash);
#my %t = %{$census_state_hash{1940}};;
#print "herei 'm you " . $t{"California"} . "\n" ;
my %census_state_hash = make_census_state_pops ();
my %census_freq = convert_to_freqs (%census_state_hash);

my %t = %{$wiki_state_hash{1940}};;
#print "herei 'm you " . $t{"California"} . "\n" ;
#total_over_all_years (%wiki_state_hash);
#print "census\n";
#total_over_all_years (%census_state_hash);
my %weight_For_Year = weight_for_year (\%wiki_state_hash, \%census_state_hash); 
my %scores = try_RR (\%wiki_state_hash, \%census_state_hash, \%weight_For_Year);
#print "end of weight for year\n";
#average_RR (\%wiki_state_hash, \%census_state_hash);

# commented out July 10,011 calculating differently to get SD
#turn_counts_into_freqs (\%wiki_state_hash, \%census_state_hash);

#my %scores = wiki_weighted_average (\%wiki_state_hash, \%census_freq  );
#foreach my $state (keys (%scores)) {
#	my $abbrev = $long_state_to_abbrev_hash{$state};
	#print $abbrev . "\t" . $scores{$state}.  "\n";
#}

exit (0);

sub
average_RR
{
        my ($wiki_state_hash_ref, $census_state_hash_ref) = @_; 

        my %wiki_state_hash = %{$wiki_state_hash_ref};
        my %census_state_hash = %{$census_state_hash_ref};
	my %rr_hash;
	my %t = %{$census_state_hash{1940}};;
        my @states = keys (%t);
	#print "in here average_RR\n";
        for (my $year = 1940; $year < 1990; $year++) {
         #       print "year $year\n";
		my $wiki_total = 0;
	        my $census_total = 0;

                my %wiki_hash = %{$wiki_state_hash{$year}};
                my %census_hash = %{$census_state_hash{$year}};
                for (my $i= 0; $i < @states; $i++) {
                        my $state = $states[$i];
                        $wiki_total += $wiki_hash{$state};
                        $census_total +=
                                 $census_hash{$state};
                }
		for (my $i= 0; $i < @states; $i++) {
			my $state = $states[$i];
			my ($rr, $rr_low_95, $rr_high_95) = RR ($wiki_hash{$state},
                $wiki_total, $census_hash{$state}, $census_total);
			$rr_hash{$state} .= $rr . ";";
		}
        }
#print "in avge RR number of states " . scalar (@states) . "\n";
	for (my $i= 0; $i < @states; $i++) {
		my $state = $states[$i];
		#print "rr_hash $rr_hash{$state}\n";
		my @nums = split (/\;/, $rr_hash{$state});
		my ($variance, $skew, $kurtosis, $standard_deviation, $mean)= 	
						variance (@nums); 
		print "avg\t$state\t$mean\t" . ($mean - 2 *$standard_deviation )
				. 
			"\t" . ($mean + 2 * $standard_deviation) . "\n";
	}
}

sub
try_RR 
{
	my ($wiki_state_hash_ref, $census_state_hash_ref, 
					$weight_For_Year_ref) = @_;

	my %wiki_weighted_count_over_all_years;
	my %census_weighted_count_over_all_years;
	
	 my %wiki_state_hash = %{$wiki_state_hash_ref};
	my %census_state_hash = %{$census_state_hash_ref};
	my %weight_For_Year = %{$weight_For_Year_ref};
	my %scores;

	 my %t = %{$census_state_hash{1980}};;
	my @states = keys (%t);
	my $wiki_total = 0;
	my $census_total = 0;

	for (my $year = 1940; $year < 1990; $year++) {
#                print "year $year\n";
                my %census_freq_hash = %{$census_state_hash{$year}};
                my %wiki_hash = %{$wiki_state_hash{$year}};
		my %census_hash = %{$census_state_hash{$year}};
		for (my $i= 0; $i < @states; $i++) {
			my $state = $states[$i];
			$wiki_weighted_count_over_all_years{$state} += 
#				$weight_For_Year{$year} * $wiki_hash{$state};	
				 $wiki_hash{$state};
			$wiki_total += $wiki_hash{$state};
#$weight_For_Year{$year} * $wiki_hash{$state};
			$census_weighted_count_over_all_years{$state} +=
				$weight_For_Year{$year} * $census_hash{$state};	
			$census_total += 
				$weight_For_Year{$year} * $census_hash{$state};	
		}
	}
	print "State\tRelative Risk\tLower 95% Confidence Interval\tUpper 95% Confidence Interal\tWiki Count for State\tCensus Count for State\tWiki Count for All States\tCensus Count for All States\n";

	for (my $i= 0; $i < @states; $i++) {
               my $state = $states[$i];
		my $a = $wiki_weighted_count_over_all_years{$state};
#		print "wiki $state  $wiki_weighted_count_over_all_years{$state}\n";
#		print "census $state   $census_weighted_count_over_all_years{$state}\n";
		print "$state\t"; #$wiki_weighted_count_over_all_years{$state}\t" . round ($census_weighted_count_over_all_years{$state}) . "\t";
		my $b = $census_weighted_count_over_all_years{$state}; 
		 my ($rr, $rr_low_95, $rr_high_95) = RR ($a,
                $wiki_total, $b, $census_total);
		$scores{$state} = $rr *100;
#		print "rr\t$state\trr\t" . 
#		print sprintf ("%.2f", $rr) . "\tlow 95\t" .
#			sprintf ("%.2f", $rr_low_95) . "\thigh\t" .
#			sprintf ("%.2f", $rr_high_95) . "\twiki numbers\t$a\t$wiki_total\tcensus\t$b\t$census_total\n";
		print sprintf ("%.2f", $rr) . "\t" .
			sprintf ("%.2f", $rr_low_95) . "\t" .
			sprintf ("%.2f", $rr_high_95) . "\t" .
			$wiki_weighted_count_over_all_years{$state} .
			"\t" . 
			round ($census_weighted_count_over_all_years{$state})
			 . "\t" .
			round($wiki_total) . "\t" . round($census_total) . "\n";
	}		
	print "########################\n";
       print "RR is calculated as State_wiki_freq / State_census_freq\n";
        print "State_wiki_freq = Wiki Count for State / Wiki Count for All States\n"; 
        print "State_census_freq = Census Count for State / Census Count for All States\n"; 

	return %scores;
}

sub
initialize_state_hash
{
	my %state_hash = make_hash ($states_abbrev_file,0,1,",");
	my $state;
	foreach $state (keys %state_hash) {
		$state_hash{$state} = 0;
	}
	return (%state_hash);

}

sub
convert_to_freqs
{
	my (%hash) = @_;
        my @decades = qw (1940 1950 1960 1970 1980);
	my %all_freq_hash;
        my $decade;
        foreach $decade (@decades) {

        for (my $year = $decade; $year < $decade+10; $year++) {
                #print "year $year\n";
                my %year_hash = %{$hash{$year}};
                my $total =0;
                # look at all states to get denominator right
               my @states = keys (%year_hash);

               for (my $i = 0; $i < @states; $i++) {
#		print "aoeu state is $states[$i]\n";
               	$total += $year_hash{$states[$i]};
               }

		my %freq_hash;
		for (my $i = 0; $i < @states; $i++) {
			$freq_hash{$states[$i]} = $year_hash{$states[$i]}/$total;
#			print "will be hashing state $states[$i] on year $year \n";
		}
		$all_freq_hash{$year} = \%freq_hash;
	}# end year
	} # end decade
	return (%all_freq_hash);
}	

sub
total_over_all_years
{
	my (%hash_all) = @_;

        my @decades = qw (1940 1950 1960 1970 1980);
	my %state_hash;
        my %s_hash = %{$hash_all{"1980"}};

	my $total = 0;
        my @states = keys (%s_hash);
        for (my $i = 0; $i < @states; $i++) {
                my $state = $states[$i];
                foreach my $decade (@decades) {
                for (my $year = $decade; $year < $decade+10; $year++) {
                	my %w_hash = %{$hash_all{$year}};
#print "state is $state year is $year\n";
               		$state_hash{$state} +=  $w_hash{$state} ;
			$total += $w_hash{$state};
		}
		}
	} 
	foreach my $state (keys %state_hash) {
		print $state . "\t" .$state_hash{$state} . "\t" .
			sprintf ("%.2f", ($state_hash{$state}/$total) * 100)
			 . " hey hey \n";		
	}
	return %state_hash;

}

sub
weight_for_year
{
	 my ($wiki_hash_ref, $census_freq_hash_ref) = @_;

	 my %census_freq_hash_all = %{$census_freq_hash_ref};
        my %wiki_hash_all = %{$wiki_hash_ref};
	 my @decades = qw (1940 1950 1960 1970 1980);
        my $wiki_total_over_all_years = 0;
        my %census_hash = %{$census_freq_hash_all{"1980"}};
        my %wiki_ratio;
        my @states = keys (%census_hash);
	my %weight_for_year;
	my %weight;


	my $wiki_total = 0;
         foreach my $decade (@decades) {
           for (my $year = $decade; $year < $decade+10; $year++) {
#                print "year $year\n";
                my %census_freq_hash = %{$census_freq_hash_all{$year}};
                my %wiki_hash = %{$wiki_hash_all{$year}};
                my $wiki_total = 0;
                my $census_total =0;

	 for (my $i = 0; $i < @states; $i++) {
		my $state = $states[$i];
#                if ($census_freq_hash{$state} > 0) {
			$wiki_total += $wiki_hash{$state}; 
#                } else {
#                        print "this state has ne census freq $state $census_freq_hash{$state} $year\n";
#                }
                        $wiki_total_over_all_years += $wiki_hash{$state};
       	} # end finish all satets
		$weight_for_year{$year} = $wiki_total;
         } # finish year
                } #finish decade
	        foreach my $decade (@decades) {
        	for (my $year = $decade; $year < $decade+10; $year++) {
#			$weight{$year} = $weight_for_year{$year} / $wiki_total_over_all_years;
			print "year $year $weight{$year} was $weight_for_year{$year} wiki total $wiki_total_over_all_years\n";
			$weight{$year} = $weight_for_year{$year} / $wiki_total_over_all_years; 
		} 
		}
		return %weight;
}

sub
wiki_weighted_average
{

        my ($wiki_hash_ref, $census_freq_hash_ref)
					 = @_;

        my @decades = qw (1940 1950 1960 1970 1980);

        my %census_freq_hash_all = %{$census_freq_hash_ref};
        my %wiki_hash_all = %{$wiki_hash_ref};

	my $wiki_total_over_all_years = 0;
	my %census_hash = %{$census_freq_hash_all{"1980"}};
	my %wiki_ratio;
	my @states = keys (%census_hash);
	for (my $i = 0; $i < @states; $i++) {
		my $state = $states[$i];
		print "state is .au,.ua $state\n";
        	my $wiki_weighted_average = 0;
		my $decade;
	        foreach $decade (@decades) {
        	for (my $year = $decade; $year < $decade+10; $year++) {
                print "year $year\n";
                my %census_freq_hash = %{$census_freq_hash_all{$year}};
                my %wiki_hash = %{$wiki_hash_all{$year}};
                my $wiki_total = 0;
                my $census_total =0;
		if ($census_freq_hash{$state} > 0) {
			$wiki_weighted_average += $wiki_hash{$state} / 
						$census_freq_hash{$state}; 
	print "state $state wiki is $wiki_hash{$state}\n";
		} else { 
			print "this state has ne census freq $state $census_freq_hash{$state} $year\n";
		}
			$wiki_total_over_all_years += $wiki_hash{$state};
		} # finish year
		} #finish decade
		$wiki_ratio{$state} = $wiki_weighted_average;
	}
	for (my $i = 0; $i < @states; $i++) {
		my $state = $states[$i];
		print "state $state $wiki_ratio{$state} number\n";
		$wiki_ratio{$state} = $wiki_ratio{$states[$i]} / $wiki_total_over_all_years * 100;
	}

	return (%wiki_ratio);
}

sub
turn_counts_into_freqs
{
	my ($wiki_hash_ref, $census_hash_ref) = @_;
	my @decades = qw (1940 1950 1960 1970 1980);

	my %census_hash_all = %{$census_hash_ref};
	my %wiki_hash_all = %{$wiki_hash_ref};
	my $wiki_total_over_all_years = 0;

        my $decade;
        foreach $decade (@decades) {

        for (my $year = $decade; $year < $decade+10; $year++) {
		#print "year $year\n";
		my %census_hash = %{$census_hash_all{$year}};
		my %wiki_hash = %{$wiki_hash_all{$year}};
		my $wiki_total = 0;
		my $census_total =0;

		# look at all states to get denominator right
		my @states = keys (%census_hash);
#		my @states = keys (%wiki_hash);

#		for (my $i = 0; $i < @states2; $i++) {
#			print "census hash $states2[$i]ki\n";;
#		}
		for (my $i = 0; $i < @states; $i++) {
			my $state = $states[$i];
			$wiki_total += $wiki_hash{$state};
			$wiki_total_over_all_years += $wiki_hash{$state};
#print "state $state has wiki $year " . $wiki_hash{$state} . "xi\n";
			$census_total += $census_hash{$state};
		}

		for (my $i = 0; $i < @states; $i++) {
                        my $state = $states[$i];
			my $wiki_freq = 0;
			if ($wiki_total > 0) {
				$wiki_freq = $wiki_hash{$state} / $wiki_total;
			}
			
			my $census_freq = $census_hash{$state} / $census_total;	
			if ($census_freq == 0) {
				print "u,eou state has $state 0 year $year\n";
			}
			if ($state =~ /^[A-Z]/) {
				print "$year\t$state\t" . $wiki_hash{$state} . "\t" .
				$wiki_freq . "\t" . $census_hash{$state}	
				. "\t" . $census_freq . "\t" .
				$wiki_freq / $census_freq * 100 . "\n";
			}	
		} # end for all states for this year		
	} # end for year 
	} # end for decade
}

sub
read_wiki_states
{
	my ($category, %state_abbrev_hash) = @_;
	
	my $wiki_total_over_all_years++;
	my %wiki_state_hash;
#	my %total_wiki_hash;

#	my @decades = qw (1940 1950 1960 1970 1980);

#	my $decade;	
#	foreach $decade (@decades) {
	
	for (my $year = 1940; $year < 1990; $year++) {
		my %state_year = initialize_state_hash();
		my $total_wiki;
		my $decade = substr ($year, 0,3);
		$decade .= "0";
		#my $file = "/home/pauline/wiki/wiki_entries/allbirthplacecleanUS/$year.allbirthplacecleanUS.Religion";
#		my $file = "/home/pauline/wiki/wiki_entries/allbirthplacecleanUS/$year.allbirthplacecleanUS"; 
#		my $file = "/home/pauline/wiki/wiki_entries/allbirthplacecleanUS/$year.allbirthplacecleanUS.Arts";
#		my $file = "/home/pauline/wiki/wiki_entries/allbirthplacecleanUS/$year.allbirthplacecleanUS.Sports";
		my $file = $outdir .  $year . ".allbirthplacecleanUS"; 
		if ($category ne "") {
			$file = $file . ".$category";
		}	
		open (IN, $file) ; # || die "can't open $file";
		my $line;
		while ($line = <IN>) {
			chomp ($line);
			my ($wiki, $place) = split (/\t/, $line);
			$_ = $place;
			/\, ([A-Za-z\ ]+$)/;
			my $state = $1;
			$state =~ s/^\s+//;

			# abbreviation for a state
			if (exists  ($state_abbrev_hash{$state})) {
                                $state = $state_abbrev_hash{$state};
			}

			if (exists ($state_year{$state})) {
				$state_year{$state}++;
				$wiki_total_over_all_years++;
#print "increasing $state wiki year $year\n";
				$total_wiki++;
			} else { 
#				print "couldn't hash on $state  $wiki \n";
			} 
		} # finished reading file
		close (IN);
		  $wiki_state_hash{$year} = \%state_year;
#		$total_wiki_hash{$year} = $total_wiki;
	} # end for year
#	} # end for decade
	
	return (%wiki_state_hash); #, \%total_wiki_hash);
}

sub 
make_census_state_pops
{

my %years;
for (my $year = 1940; $year <= 1990; $year += 10) {
	my $file =  $data_dir . "/" . $year . "_state_pops";
	my %tmp_hash = make_hash ($file, 1,2, "\t");
	my %tmp2_hash;
	my $state;
	foreach $state (keys (%tmp_hash)) {
		$tmp_hash{$state} =~ s/\,//g;
		my $v =  $tmp_hash{$state};
		$state =~ s/\s+$//;
		$tmp2_hash{$state} =  $v;
		# get rid of extra spaces in states
		
#		print "hashing " . $tmp2_hash{$state} . " onto $state.,u\n";
	}
	$years{$year} = \%tmp2_hash;
}

for (my $year = 1940; $year <= 1989; $year++) {
	if (exists ($years{$year})) { # data exists, don't interpolatee
		my %state_hash = %{$years{$year}};
		my $state;
#		foreach $state (keys (%state_hash)) {
#			print "$year\t$state\t" . $state_hash{$state} . "\n";
#		}
	} else {
		my $low_year = floor ($year /10) * 10;
		my $upper_year = ceil ($year/10) * 10;
		my %new_state_hash;
		my %low_state_hash = %{$years{$low_year}};
		my %upper_state_hash = %{$years{$upper_year}};
	
		my $state;
		foreach $state (keys (%low_state_hash)) {	
		my $low_year_pop = $low_state_hash{$state};
		my $upper_year_pop = $upper_state_hash{$state}; 
		my $new_pop = $low_year_pop + 
				($year - $low_year) *  ($upper_year_pop - $low_year_pop) / ($upper_year - $low_year);
		$new_state_hash{$state} = $new_pop;
#		print "$year\t$state\t" . $new_state_hash{$state} . "\n";
		} # gone through all states	
		$years{$year} = \%new_state_hash;	
	}
}
	return (%years);
} # end function

 
