#!/usr/bin/perl
#use strict;
$| = 1;
use Class::Struct;
require "config.pl";

my $wiki_file = $outdir . "famous_people_1940-1989_cleanUS.Arts";

struct Name => {
	frequency  => '$',
	ss_count => '$',
	sex => '$',
	wiki_count => '$',
	name => '$',
	rank => '$', 
};

struct ClusterNames => {
	allnames => '$',
	total_frequency => '$', 
	cluster_id => '$'
};

#my $year = "1960";
#my %names = make_names_hash ("/usr/local/projects/HUREF6/analysis_png/src/perlscripts/wiki_search/baby_names/popularnames_" . $year . ".txtwithfreq.csv") ;

my %names = make_names_hash2 ($name_freq_file ); 
#"../baby_names/popularnames_1940-1989.csv");
# different format for all years versus per year

#my $wiki_file = "../" . $year . "/famous_people";

#my $wiki_file = "../wiki_entries/famous_people/famous_people_1940-1989";
#my $wiki_file = "/home/pauline/wiki/wiki_entries/allbirthplacecleanUS/famous_people_1940-1989_cleanUS.Arts";
#my $wiki_file = "/home/pauline/wiki/wiki_entries/allbirthplacecleanUS/famous_people_1940-1989_cleanUS";

#wiki_search/famous-people_1940-1980s";

#my $outfile = $wiki_file . "s_ssa_comparison_no_nicknames";
my $outfile = $wiki_file . "s_ssa_comparison";
print "outfile is $outfile\n";

open (WIKI, $wiki_file) || die "can't open $wiki_file";
open (OUT, ">$outfile") || die "can't open $outfile";

my $line;
my $male_wiki_count = 0; my $female_wiki_count = 0;

while ($line = <WIKI>)  {
	chomp ($line);
	my ($name, $count) = split (/\s+/, $line);
#print "checking $name\n";
	$name = lc ($name);
	if (exists ($names{$name})) {
		$names{$name}->wiki_count ($count);
		if ($names{$name}->sex eq "Male") {
			$male_wiki_count += $count;
		} else {
			$female_wiki_count += $count;
		}
	} else { 
#		print $line . "\t" . "Not_in_SS\n";
	}
}
close (WIKI);
#print_name_hash ($male_wiki_count, $female_wiki_count, %names);
#exit (0);

#my %clus_nick_hash = read_nicknames ("../nicknames_blank.txt" ); 

my %clus_nick_hash = read_nicknames ($nicknames_file);  #"../nicknames.txt" );

#print_cluster_nicknames (%clus_nick_hash);

clean_cluster_by_sex (\%clus_nick_hash, \%names);
renormalize_to_cluster (\%clus_nick_hash, \%names);
#print "END2\n";
print "male wiki count $male_wiki_count female $female_wiki_count\n";
print_name_hash ($male_wiki_count, $female_wiki_count,%names);
close (OUT);
exit (0);

sub
print_name_hash
{
	my ($male_wiki_count, $female_wiki_count, %name_hash) = @_;

	for my $name (keys %names) {
       	 	my $wiki_freq = $names{$name}->wiki_count;
        	if ($names{$name}->sex eq "Male" || 
				$names{$name}->sex =~ /Male/) {
               		 $wiki_freq = $wiki_freq / $male_wiki_count *100;
	        } else {
                	$wiki_freq = $wiki_freq / $female_wiki_count * 100;
        	}
	        if ($names{$name}->frequency > 0) {
		my $ratio = $wiki_freq / $names{$name}->frequency;
       		 print OUT $names{$name}->name . "\t" . $names{$name}->rank . "\t"
		 . $names{$name}->wiki_count . "\t" . 
			sprintf ("%.3f", $wiki_freq) . 
			"\t" . sprintf ("%.3f", $names{$name}->frequency) 
			 . "\t" .
         sprintf ("%.3f", $ratio) . "\t" . $names{$name}->sex . 
			"\t" . sprintf ("%.3f", $names{$name}->ss_count) . "\n";
		}
	}

}

sub
clean_cluster_by_sex
{
        my ($clus_nick_hash_ref, $name_hash_ref) = @_;
        my %name_hash = %{$name_hash_ref};

        my $key;
        foreach $key (keys %clus_nick_hash ) {
                my %names = %{$clus_nick_hash{$key}->allnames};

		my %male_names;
		my %female_names;

		foreach my $name (keys %names) {
			 if (exists ($name_hash{$name})) { # make sure it's in top 1000
			if ($name_hash{$name}->sex eq "Male") {
				$male_names{$name} = 1;
			} else {
				$female_names{$name} = 1;
			}
			}
		}
# shorthand perl
		my $male_count = scalar (keys (%male_names)) > 0 
					?  scalar (keys (%male_names)): 0;
		my $female_count = scalar (keys (%female_names)) > 0 
					?  scalar (keys (%female_names)) : 0;
#print "male count $male_count female $female_count\n";
		if ($male_count > $female_count) {
			$clus_nick_hash{$key}->allnames ( \%male_names);
			if ($female_count > 1) {
				# chri christina christopher separating
				my $key_id = $key . "Alt";
				my $k =  ClusterNames->new(); 
				$k->allnames (\%female_names);
				$k->cluster_id ( $key_id);
				$k->total_frequency ( 0);
				$clus_nick_hash{$key_id} = $k;
			}	
		} else {
			$clus_nick_hash{$key}->allnames ( \%female_names);
			 if ($male_count > 1) {
                                # chri christina christopher separating
                                my $key_id = $key . "Alt";
                                my $k =  ClusterNames->new(); 
                                $k->allnames (\%male_names);
                                $k->cluster_id  ($key_id);
                                $k->total_frequency ( 0);
                                $clus_nick_hash{$key_id} = $k;
                        }


		}

		
	}
}

sub
renormalize_to_cluster
{
	my ($clus_nick_hash_ref, $name_hash_ref) = @_;
	my %name_hash = %{$name_hash_ref};

	my $key;
        foreach $key (keys %clus_nick_hash ) {
                my %names = %{$clus_nick_hash{$key}->allnames};
#                print "cluster id $key\t";
		my $new_name_with_cluster_id = Name->new();
		my $frequency = 0;
		my $sex ="";
		my $wiki_count = 0;
                my $entered = 0;
		my $ss_count = 0;
		my $current_rank = 9999;
		foreach my $name (keys %names) {
#print "cluster count $key name is $name\n"; 
			if (exists ($name_hash{$name})) {
               	 		$entered = 1;
#print "cluster count $key name is $name adding " . $name_hash{$name}->frequency . " to $frequency wiki count current: $wiki_count adding " . $name_hash{$name}->wiki_count . "\n";
				$frequency += $name_hash{$name}->frequency;
				$sex .= $name_hash{$name}->sex;
				$wiki_count += $name_hash{$name}->wiki_count;
				$ss_count += $name_hash{$name}->ss_count; 

				if ($name_hash{$name}->rank < $current_rank) {
					$current_rank = $name_hash{$name}->rank;
				}
# OPTION: if want to remove the nickname as its own entry
				delete $name_hash_ref->{$name};
			}
		}
#		print "end $frequency $sex and wik $wiki_count\n";
		$new_name_with_cluster_id->frequency ($frequency);
		 $new_name_with_cluster_id->sex ($sex);
		 $new_name_with_cluster_id->ss_count ($ss_count);
		$new_name_with_cluster_id->wiki_count ($wiki_count);
		 $new_name_with_cluster_id->rank ($current_rank);
		 $new_name_with_cluster_id->name (join (',', keys (%names)));
		if ($entered) {
#print "i've entered\n";
			$name_hash_ref->{$key} = $new_name_with_cluster_id;	
		}
        }

}

sub
print_cluster_nicknames
{
	my (%clus_nick_hash) = @_;
	my $key;
	foreach $key (keys %clus_nick_hash ) { 
		my %names = %{$clus_nick_hash{$key}->allnames};
		print "cluster id $key\t";
		foreach my $name (keys %names) {
			print $name .",";
		} 
		print "\n";	
	}
	print "END\n";
}

sub
read_nicknames
{
	my ($file) = @_;

	open (NICK, $file) || die "can't open $file";
	my $line;
	my $cluster_num = 1;
	my %nick_hash; my %clus_nick_hash;
	while ($line = <NICK>) {
		unless ($line =~ /^#/) {
#print "in nickname file\n";
			chomp ($line);
			my ($nickname, $formal_name, $freq) = 
					split (/\s+/, $line);
#print $line . "\n";		
			$nickname = lc ($nickname);
			$formal_name = lc ($formal_name);
			if (exists ($nick_hash{$nickname}) && 
                                exists ( $nick_hash{$formal_name}) ){
				# lines must be unique, so what this is linking up 2 already clusters
				# i.e. Cluster1: Rich & Richard  Cluster 2: Derick Rick
				# then see a line of Rick and Richard
				my $t = $nick_hash{$nickname};
				my $t_id = $t->cluster_id;
				my $formal_id = $nick_hash{$formal_name}->cluster_id;
				if ($t_id != $formal_id) {
				my %tmp_hash = %{$t->allnames};
				my @tmp_names = keys (%tmp_hash);
				my $c = $nick_hash{$formal_name};
				for (my $i = 0; $i < @tmp_names; $i++) {
                                $c->allnames->{$tmp_names[$i]} = 1;
                                $nick_hash{$tmp_names[$i]} = $c;
                                $nick_hash{$formal_name} = $c;
				}	
				delete $clus_nick_hash{$t_id}; 
#print "deleting because of merge cluster num $t_id formal $formal_id\n";
				}
			} elsif (exists ($nick_hash{$nickname}) ||
				exists ( $nick_hash{$formal_name}) ){	

#print "joining up cluster\n";
				my $key;
				if (exists  ($nick_hash{$nickname})) {
					$key = $nickname;
				} else {
					$key=$formal_name;
				}	
				my $c = $nick_hash{$key};
				my $cluster_id = $c->cluster_id;
				$c->allnames->{$nickname} = 1;
				$c->allnames->{$formal_name} = 1;
				$nick_hash{$nickname} = $c;
				$nick_hash{$formal_name} = $c;	
				$clus_nick_hash{$cluster_id}=$c;
#print "cluster id being assigne is $cluster_id\n";
				my @tmp = keys %{$c->allnames};
				#print "array @tmp\n";	
			} # join up
			else { # make new cluster
				my $c = ClusterNames->new(); 
				my %hash;
				$c->allnames ( \%hash);
				$c->allnames->{$nickname} = 1;
				$c->allnames->{$formal_name}=1;
				$c->cluster_id($cluster_num);
				$nick_hash{$nickname}=$c;
				$nick_hash{$formal_name}= $c; 
				$clus_nick_hash{$cluster_num}=$c;
#print "hashing on $formal_name and $nickname cluster $cluster_num\n";
				$cluster_num++;
			}
		} # end unless comment
	} # end read file
	close (NICK);
	return (%clus_nick_hash);
}

sub
make_names_hash2
{
	my ($file) = @_;
        my %hash;
        open (IN2, $file) || die "can't open $file";
        while (<IN2>) {
                chomp;
                unless (/^#/) {
                my @fields = split (/\,/);
                my $new_name = Name->new();
#print "hashing on $fields[1] end\n";
                my $name = lc($fields[1]);
                $new_name->sex ($fields[4]); 
                $new_name->frequency ($fields[3]);
		$new_name->ss_count ($fields[2]);
                $new_name->name ($name);
                $new_name->rank ($fields[0]);
                $new_name->wiki_count (0);
                if (exists ($hash{$name})) {
                        # it could be a girl name, see what is higher frequency
                        # or could add it up
			  if ($fields[3] > $hash{$name}->frequency) {
                                 $hash{$name} = $new_name;
                        }
                } else {
                        $hash{$name} = $new_name;
                }
		} # end unless reading file
	} # finish reading file
        close (IN2);
        return %hash;

}

sub
make_names_hash
{
	my ($file) = @_;
	my %hash;
	open (IN2, $file) || die "can't open $file";
	while (<IN2>) {
		chomp;
		unless (/^#/) {
		my @fields = split (/\,/);
		my $new_boy_name = Name->new();
		my $boy_name = lc($fields[1]);
		$new_boy_name->sex ("Male");
		$new_boy_name->frequency ($fields[3]);
		$new_boy_name->name ($boy_name);
		$new_boy_name->rank ($fields[0]);
		$new_boy_name->wiki_count (0);
		if (exists ($hash{$boy_name})) {
			# it could be a girl name, see what is higher frequency
			# or could add it up		 
			 if ($fields[3] > $hash{$boy_name}->frequency) {
				 $hash{$boy_name} = $new_boy_name;	
			}				
		} else {
			$hash{$boy_name} = $new_boy_name;
		}


		#do the same for girls

		my $new_girl_name = Name->new();
                my $girl_name = lc($fields[4]);
                $new_girl_name->sex ("Female");
                $new_girl_name->frequency ($fields[6]);
       		$new_girl_name->name ($girl_name);
		$new_girl_name->rank ($fields[0]);
	        $new_girl_name->wiki_count (0);
		 if (exists ($hash{$girl_name}) ) {
                        # it could be a girl name, see what is higher frequency                         # or could add it up
                        ##$hash{$girl_name}->seq ("MaleFemale");
                        ##$hash{$girl_name}->frequency ($hash{$girl_name}->frequency + $fields[6]); 

			if ($fields[6] > $hash{$girl_name}->frequency) {
				# more frequent in girl than guy
				$hash{$girl_name} = $new_girl_name;

			}
                } else {
                        $hash{$girl_name} = $new_girl_name;
                }


		}
	}
	close (IN2);
	return %hash;

}


