#!/opt/local/bin/perl5 -w
use POSIX;
require "./STAT.pl";
require "./config.pl";

#my $year = "1960";
#my $file = "/usr/local/projects/HUREF6/analysis_png/src/perlscripts/wiki_search/famous-people_" . $year . "s_ssa_comparison";

#my $file = "/home/pauline/wiki/wiki_entries/famous_people/famous_people_1940-1989s_ssa_comparison";
my $file = $outdir . "famous_people_1940-1989_cleanUSs_ssa_comparison";
print "file $file\n";

#my $file = "/home/pauline/wiki/wiki_entries/allbirthplacecleanUS/famous_people_1940-1989_cleanUS.Artss_ssa_comparison";

$lower_threshold = -3;
$upper_threshold = 2; 
$bin_width = 1  ; 
$bin_size = ($upper_threshold - $lower_threshold )/ $bin_width;

my @sex_a ; $sex_a[0] = "Female"; $sex_a[1] = "Male";

for (my $sex_index = 0; $sex_index < @sex_a; $sex_index++) {
	$sex = $sex_a[$sex_index];
	my $other_sex = $sex_index == 0 ?  $sex_a[1] :  $sex_a[0];
print "sex is $sex other sex is $other_sex\n";
	$outfile = $file . $sex . ".tsv";
	open (OUT, ">$outfile") || die "can't open $outfile"; 
my @results =  `cat $file | grep $sex | grep -v $other_sex`;

my @ssa_sum_a;
my @ssa_count_a;
my @wiki_count_a;
my @wiki_sum_a;
my $wiki_count_total = 0;
my $ssa_count_total = 0;

#initialize

for ($i = 0; $i < $bin_size; $i++) {
        $ssa_sum_a[$i] = 0;
	$wiki_sum_a[$i] = 0;
	$wiki_count_a[$i] = 0;
	$ssa_count_a[$i] = 0;
}
 for (my $j = 0; $j < @results; $j++) {
	my $line = $results[$j];
	chomp ($line);

        my @fields = split (/\s+/, $line);
 	$wiki_count = $fields[2] ; 
	$wiki_sum = $fields[3];
	$ssa_sum = $fields[4];
	$ssa_count = $fields[7];
	# bin depends on social security frequency

        if ($ssa_sum > 0) {

                $index = floor ((log($ssa_sum)/log (10) - $lower_threshold) / $bin_width) ;
                if ($index < 0) { $index = 0;}
		if ($index > $bin_size ) {$index = $bin_size;}
                $wiki_count_a[$index] += $wiki_count;
		$wiki_sum_a[$index] += $wiki_sum;
		$ssa_sum_a[$index] += $ssa_sum;
		$ssa_count_a[$index] += $ssa_count;

		$wiki_count_total += $wiki_count;
		$ssa_count_total += $ssa_count;
        }

} # end for gone through results 

close (IN);

$total = 0;

# for values exceeding binsize, add to last bin
for ($i = $bin_size; $i < @size; $i++) {
        if (exists ($size[$i]) ) {
		$size[$bin_size - 1] += $size[$i];
	}
}



for ($i = 0; $i < $bin_size; $i++) {
        $range = $i * $bin_width + $lower_threshold;
#       print OUT "$range\t$size[$i]\n";
        $total += $size[$i];
}

print OUT "Range (Frequency of Names)\t10^-x\tNumber of Names in Wikipedia in this Range\tTotal Frequency in Wikipedia for this Range\tSocial Security Population for this Range\tSSA Frequency\tRelative Risk (Wikipedia Frequency/SSA Frequency)\tLower Bound of 95% CI\tUpper Bound of 95% CI\tTotal Wiki Entries Over all Frequencies\tTotal Population Over All Frequencies\n"; 
for ($i = 0; $i < $bin_size; $i++) {
        $range = $i * $bin_width + $lower_threshold;
        $cumul_count += $size[$i];
	my $exp_range = 10 ** $range;
	my $fraction = $ssa_sum_a[$i] > 0 ? ($wiki_sum_a[$i] / $ssa_sum_a[$i]) : 0;
	my ($rr, $rr_low_95, $rr_high_95) = RR ($wiki_count_a[$i], 
		$wiki_count_total, $ssa_count_a[$i], $ssa_count_total);
#	my ($or, $or_low_95, $or_high_95) = OR ($wiki_count_a[$i],
#                $wiki_count_total - $wiki_count_a[$i], $ssa_count_a[$i], 
#		$ssa_count_total - $ssa_count_a[$i]);

	print OUT "$exp_range\t$range\t" . $wiki_count_a[$i] . "\t" . $wiki_sum_a[$i] . "\t" . $ssa_count_a[$i] . "\t" . $ssa_sum_a[$i] . "\t" . #$fraction\t
	"$rr\t$rr_low_95\t$rr_high_95\t";  #
	#$or\t$or_low_95\t$or_high_95\t
	print OUT "$wiki_count_total\t$ssa_count_total\n";
}
close (OUT);
} # end for each sex
exit (0);

